core/urls.py
from django.contrib.auth.views import LogoutView
from django.urls import path, include
from mfa import FIDO2
from two_factor.views import QRGeneratorView

from core import views

app_name = 'auth'

biometry_urls = [
    path('begin_auth/', FIDO2.authenticate_begin, name="biometric_auth_begin"),
    path('complete_auth/', views.BiometricAuthAjaxView.as_view(), name='biometric_auth_complete'),
    path('begin_reg/', FIDO2.begin_registeration, name="biometric_reg_begin"),
    path('complete_reg/', FIDO2.complete_reg, name="biometric_reg_complete"),
]

two_factor_urls = [
    path('qr', QRGeneratorView.as_view(), name='tf_qr'),
    path('', views.TwoFactorAuthView.as_view(), name='tf_auth'),
]


urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('registration/', views.RegistrationView.as_view(), name='registration'),
    path('logout/', LogoutView.as_view(), name='logout'),
    path('postauth/', views.PostAuthView.as_view(), name='post_auth'),
    path('profile/<pk>', views.ProfileView.as_view(), name='profile'),

    path('two_factor/', include(two_factor_urls)),
    path('biometric/', include(biometry_urls)),
]

multi_auth/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic import RedirectView


urlpatterns = [
    path('admin/', admin.site.urls),
    path('',  RedirectView.as_view(url=reverse_lazy('auth:index'), permanent=True)),
    path('auth/', include('core.urls', namespace='auth')),
]

templates/base.html
{% load static %}
{% load bootstrap5 %}
<!DOCTYPE html>

<html>
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1"/>
    <title>{% block title %}Multi Auth by Mixxxxer{% endblock title %}</title>

    <!-- Favicons -->
    <link rel="icon" type="image/png" sizes="16x16" href="{% static 'favicon/favicon-16x16.png' %}" />
    <link rel="icon" type="image/png" sizes="32x32" href="{% static 'favicon/favicon-32x32.png' %}" />
    <link rel="icon" type="image/png" sizes="192x192" href="{% static 'favicon/apple-touch-icon.png' %}" />

    <!--  Jquery -->
    <script src="https://code.jquery.com/jquery-3.3.1.js" integrity="sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60=" crossorigin="anonymous"></script>

    <!-- Bootstrap -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">

    <!-- Font Awesome -->
    <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0/css/all.min.css" rel="stylesheet"/>

    <!-- Google Fonts -->
    <link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700&display=swap" rel="stylesheet"/>

    <!-- MDB -->
    <link href="https://cdnjs.cloudflare.com/ajax/libs/mdb-ui-kit/4.0.0/mdb.min.css" rel="stylesheet"/>

    <!-- Project css -->
    <link rel="stylesheet" href="{% static 'css/base.css' %}">

    {% block css %}{% endblock css %}

</head>

<body>

<nav class="navbar navbar-dark bg-primary">
    <div class="navbar-header">
          <a class="navbar-brand" href="{% url 'auth:index' %}">
              <img class="custom-logo" src="{% static 'img/logo.png' %}">
              MultiAuth by&nbsp;<b>Mixxxxer</b>
          </a>
    </div>

    {% if request.user.is_authenticated %}
            <div class="dropdown">
                <button class="btn btn-success dropdown-toggle" type="button" id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false">
                    {{ request.user.username }}
                </button>
                <ul class="dropdown-menu">
                    <li>
                        {% url 'auth:profile' pk=user.pk as profile_url %}
                        {% bootstrap_button content='Profile' button_class='btn-warning' href=profile_url %}
                    </li>
                    <li>
                        {% url 'auth:logout' as logout_url %}
                        {% bootstrap_button content='Logout' button_class='btn-warning' href=logout_url %}
                    </li>
                </ul>
            </div>
    {% else %}
        <div class="btn-group">
            {% url 'auth:index' as index_url %}
            {% bootstrap_button content='Auth' button_class='btn-success' href=index_url %}
            {% url 'auth:registration' as registation_url %}
            {% bootstrap_button content='Registration' button_class='btn-success' href=registation_url %}
        </div>
    {% endif %}

</nav>

{% if messages %}
    {% bootstrap_messages messages %}
{% endif %}

<div class="container" role="main">
    {% block content %}
    {% endblock content %}
</div>

<!-- JS -->
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mdb-ui-kit/4.0.0/mdb.min.js"></script>
{% block js %}{% endblock js %}

</body>

</html>

templates/index.html
{% extends "base.html" %}
{% load helpers %}
{% load bootstrap5 %}
{% load static %}


{% block js %}
    <script src="{% static 'js/cbor.js' %}"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/UAParser.js/0.7.20/ua-parser.min.js"></script>
    <script src="{% static 'js/fingerprint.js'%}"></script>
{% endblock js %}

{% block content %}

    <ul class="nav nav-tabs nav-justified mb-3" role="tablist">
        <li class="nav-item" role="presentation">
            <a class="nav-link{% if active_field == 'password' %} active{% endif %}" data-mdb-toggle="tab" href="#password-auth" role="tab" aria-selected="true">Password authentication</a>
        </li>
        <li class="nav-item" role="presentation">
            <a class="nav-link{% if active_field == 'two_factor' %} active{% endif %}" data-mdb-toggle="tab" href="#tf-auth" role="tab" aria-selected="false">Two-factor authentication</a>
        </li>
        <li class="nav-item" role="presentation">
            <a class="nav-link{% if active_field == 'digital_sign' %} active{% endif %}" data-mdb-toggle="tab" href="#ds-auth" role="tab" aria-selected="false">Digital signature authentication</a>
        </li>
        <li class="nav-item" role="presentation">
            <a class="nav-link{% if active_field == 'biometric' %} active{% endif %}" data-mdb-toggle="tab" href="#biometry-auth" role="tab" aria-selected="false">Biometric authentication</a>
        </li>
    </ul>

    <div class="tab-content">
        <div class="tab-pane fade{% if active_field == 'password' %} show active{% endif %}" id="password-auth" role="tabpanel">
            {% include 'includes/auth_form.html' with form=password_auth_form auth_type='password' button_value='Authenticate me!' %}
        </div>
        <div class="tab-pane fade{% if active_field == 'two_factor' %} show active{% endif %}" id="tf-auth" role="tabpanel">
            {% include 'includes/auth_form.html' with form=two_factor_auth_form auth_type='two_factor' button_value='Next' %}
        </div>
        <div class="tab-pane fade{% if active_field == 'digital_sign' %} show active{% endif %}" id="ds-auth" role="tabpanel">
            {% include 'includes/auth_form.html' with form=digital_sign_auth_form auth_type='digital_sign' button_value='Authenticate me!' %}
        </div>
        <div class="tab-pane fade{% if active_field == 'biometric' %} show active{% endif %}{% if not biometric_auth_form %} text-center{% endif %}" id="biometry-auth" role="tabpanel">
            {% if biometric_auth_form %}
                {% include 'includes/auth_form.html' with form=biometric_auth_form auth_type='biometric' button_value='Next' %}
            {% else %}
                Click button to start biometric authentication.
                <hr>
                {% bootstrap_button id='auth-biometry' content='Authenticate me!' %}
                <input type="hidden" id="biometry_begin_auth" data-url-selected="{% url 'auth:biometric_auth_begin' %}">
                <input type="hidden" id="biometry_complete_auth" data-url-selected="{% url 'auth:biometric_auth_complete' %}">
            {% endif %}
        </div>
    </div>

{% endblock content %}

templates/post_auth.html
{% extends 'base.html' %}
{% load bootstrap5 %}


{% block content %}
    <div class="text-center">
        You were successfully authenticated as {{ user.username }} using {{ auth_type }} based authentication
    </div>
    <hr>
    <table class="table table-striped">
      <thead>
        <tr>
          <th>Data key</th>
          <th>Data received in POST</th>
          <th>Data stored in DB</th>
        </tr>
      </thead>
      <tbody>
      {% for key, values in table_data.items %}
      <tr>
      <td>{{ key }}</td>
      <td>{{ values.0|default:'Not stored' }}</td>
      <td>{{ values.1|default:'Not stored' }}</td>
      </tr>
      {% endfor %}
      </tbody>
    </table>

    <div class="text-center">
        {% url 'auth:profile' pk=user.pk as profile_url %}
        {% bootstrap_button content='Profile' button_class='btn-warning' href=profile_url size='large' %}
        {% url 'auth:logout' as logout_url%}
        {% bootstrap_button content='Logout' button_class='btn-warning text-center' href=logout_url size='large' %}
    </div>

{% endblock content %}

templates/profile.html
{% extends 'base.html' %}
{% load helpers %}
{% load bootstrap5 %}
{% load static %}


{% block js %}
    <script src="{% static 'js/cbor.js'%}"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/UAParser.js/0.7.20/ua-parser.min.js"></script>
    <script src="{% static 'js/fingerprint.js'%}"></script>
{% endblock js %}

{% block content %}
    <div class="text-center">
        Hi there, {{ user.username }}. You can add following auth methods:
    </div>
    <hr>

    <ul class="nav nav-tabs nav-justified mb-3" role="tablist">
        <li class="nav-item" role="presentation">
            <a class="nav-link{% if active_field == 'two_factor' %} active{% endif %}" data-mdb-toggle="tab" href="#tf-auth" role="tab" aria-selected="false">Two-factor</a>
        </li>
        <li class="nav-item" role="presentation">
            <a class="nav-link{% if active_field == 'digital_sign' %} active{% endif %}" data-mdb-toggle="tab" href="#ds-auth" role="tab" aria-selected="false">Digital signature</a>
        </li>
        <li class="nav-item" role="presentation">
            <a class="nav-link{% if active_field == 'biometry_auth' %} active{% endif %}" data-mdb-toggle="tab" href="#biometry-auth" role="tab" aria-selected="false">Biometry</a>
        </li>
    </ul>

    <div class="tab-content">
        <div class="tab-pane fade{% if active_field == 'two_factor' %} show active{% endif %}" id="tf-auth" role="tabpanel">
            To start using a token generator, please use your smartphone to scan the QR code below.
            For example, use Google Authenticator. Then, enter the token generated by the app.
            <hr>
            <p class="text-center"><img src="{% url 'auth:tf_qr' %}" alt="QR Code" /></p>
            {% include 'includes/auth_form.html' with form=two_factor_form auth_type='two_factor' button_value='Proceed'%}
        </div>
        <div class="tab-pane fade{% if active_field == 'digital_sign' %} show active{% endif %}" id="ds-auth" role="tabpanel">
            <form method="POST">{% csrf_token %}
                To generate digital signature, enter key password:
                <hr>
                {% include 'includes/auth_form.html' with form=digital_sign_form auth_type='digital_sign' button_value='Proceed'%}
            </form>
        </div>
        <div class="tab-pane fade{% if active_field == 'biometry_auth' %} show active{% endif %}" id="biometry-auth" role="tabpanel">
            To add biometric authentication method, press the button and scan your fingerprint
            <hr>
            <div class="text-center" id="res">
                {% bootstrap_button id='add-biometry' content='Add fingerpint' %}
            <input type="hidden" id="biometry_begin_reg" data-url-selected="{% url 'auth:biometric_reg_begin' %}">
            <input type="hidden" id="biometry_complete_reg" data-url-selected="{% url 'auth:biometric_reg_complete' %}">
            <input type="hidden" id="success_url" data-url-selected="{% absolute_url 'auth:index' %}">
        </div>
    </div>

{% endblock content %}

templates/registration.html
{% extends "base.html" %}
{% load bootstrap5 %}


{% block content %}

<form method="POST">{% csrf_token %}
    {% bootstrap_form form %}
    <hr>
    <div class="text-center">
        {% bootstrap_button 'Register' %}
    </div>
</form>

{% endblock content %}

templates/two_factor_auth.html
{% extends "base.html" %}
{% load bootstrap5 %}


{% block content %}
    Please enter token generated by your token generator.
    <hr>
    {% include 'includes/auth_form.html' with form=form auth_type='two_auth' button_value='Authenticate me!' %}

{% endblock content %}